/* playlist-file.c generated by valac 0.56.14, the Vala compiler
 * generated from playlist-file.vala, do not modify */

#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define G4_PLAY_LIST_TYPE_NONE ((guint) 0)
#define G4_PLAY_LIST_TYPE_M3U ((guint) 1)
#define G4_PLAY_LIST_TYPE_PLS ((guint) 2)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN guint g4_get_playlist_type (const gchar* mimetype);
VALA_EXTERN gboolean g4_is_playlist_file (const gchar* mimetype);
VALA_EXTERN gboolean g4_is_valid_uri (const gchar* uri,
                          GUriFlags flags);
VALA_EXTERN gchar* g4_load_playlist_file (GFile* file,
                              GPtrArray* uris);
VALA_EXTERN gchar* g4_load_m3u_file (GFile* file,
                         GPtrArray* uris,
                         GError** error);
VALA_EXTERN gchar* g4_load_pls_file (GFile* file,
                         GPtrArray* uris,
                         GError** error);
VALA_EXTERN gchar* g4_parse_relative_uri (const gchar* uri,
                              GFile* parent);
VALA_EXTERN gchar* g4_get_file_display_name (GFile* file);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

guint
g4_get_playlist_type (const gchar* mimetype)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 10 "../src/utils/playlist-file.vala"
	static GQuark _tmp1_label0 = 0;
#line 10 "../src/utils/playlist-file.vala"
	static GQuark _tmp1_label1 = 0;
#line 61 "playlist-file.c"
	guint result;
#line 9 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (mimetype != NULL, 0U);
#line 10 "../src/utils/playlist-file.vala"
	_tmp0_ = mimetype;
#line 10 "../src/utils/playlist-file.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 10 "../src/utils/playlist-file.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("audio/x-mpegurl")))) {
#line 10 "../src/utils/playlist-file.vala"
		switch (0) {
#line 73 "playlist-file.c"
			default:
			{
#line 12 "../src/utils/playlist-file.vala"
				result = G4_PLAY_LIST_TYPE_M3U;
#line 12 "../src/utils/playlist-file.vala"
				return result;
#line 80 "playlist-file.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("audio/x-scpls")))) {
#line 10 "../src/utils/playlist-file.vala"
		switch (0) {
#line 86 "playlist-file.c"
			default:
			{
#line 14 "../src/utils/playlist-file.vala"
				result = G4_PLAY_LIST_TYPE_PLS;
#line 14 "../src/utils/playlist-file.vala"
				return result;
#line 93 "playlist-file.c"
			}
		}
	} else {
#line 10 "../src/utils/playlist-file.vala"
		switch (0) {
#line 99 "playlist-file.c"
			default:
			{
#line 16 "../src/utils/playlist-file.vala"
				result = G4_PLAY_LIST_TYPE_NONE;
#line 16 "../src/utils/playlist-file.vala"
				return result;
#line 106 "playlist-file.c"
			}
		}
	}
}

gboolean
g4_is_playlist_file (const gchar* mimetype)
{
	gboolean result;
#line 20 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (mimetype != NULL, FALSE);
#line 21 "../src/utils/playlist-file.vala"
	result = g4_get_playlist_type (mimetype) != G4_PLAY_LIST_TYPE_NONE;
#line 21 "../src/utils/playlist-file.vala"
	return result;
#line 122 "playlist-file.c"
}

gboolean
g4_is_valid_uri (const gchar* uri,
                 GUriFlags flags)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 24 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 133 "playlist-file.c"
	{
		gboolean _tmp0_ = FALSE;
#line 26 "../src/utils/playlist-file.vala"
		_tmp0_ = g_uri_is_valid (uri, flags, &_inner_error0_);
#line 26 "../src/utils/playlist-file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "playlist-file.c"
			goto __catch0_g_error;
		}
#line 26 "../src/utils/playlist-file.vala"
		result = _tmp0_;
#line 26 "../src/utils/playlist-file.vala"
		return result;
#line 147 "playlist-file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 25 "../src/utils/playlist-file.vala"
		g_clear_error (&_inner_error0_);
#line 154 "playlist-file.c"
	}
	__finally0:
#line 25 "../src/utils/playlist-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "playlist-file.c"
		gboolean _tmp1_ = FALSE;
#line 25 "../src/utils/playlist-file.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 25 "../src/utils/playlist-file.vala"
		g_clear_error (&_inner_error0_);
#line 25 "../src/utils/playlist-file.vala"
		return _tmp1_;
#line 167 "playlist-file.c"
	}
#line 29 "../src/utils/playlist-file.vala"
	result = FALSE;
#line 29 "../src/utils/playlist-file.vala"
	return result;
#line 173 "playlist-file.c"
}

gchar*
g4_load_playlist_file (GFile* file,
                       GPtrArray* uris)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 32 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 32 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 186 "playlist-file.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		const gchar* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		const gchar* _tmp3_;
		guint type = 0U;
#line 34 "../src/utils/playlist-file.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 34 "../src/utils/playlist-file.vala"
		info = _tmp0_;
#line 34 "../src/utils/playlist-file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "playlist-file.c"
			goto __catch0_g_error;
		}
#line 35 "../src/utils/playlist-file.vala"
		_tmp2_ = info;
#line 35 "../src/utils/playlist-file.vala"
		_tmp3_ = g_file_info_get_content_type (_tmp2_);
#line 35 "../src/utils/playlist-file.vala"
		_tmp1_ = _tmp3_;
#line 35 "../src/utils/playlist-file.vala"
		if (_tmp1_ == NULL) {
#line 35 "../src/utils/playlist-file.vala"
			_tmp1_ = "";
#line 213 "playlist-file.c"
		}
#line 35 "../src/utils/playlist-file.vala"
		type = g4_get_playlist_type ((const gchar*) _tmp1_);
#line 36 "../src/utils/playlist-file.vala"
		switch (type) {
#line 36 "../src/utils/playlist-file.vala"
			case G4_PLAY_LIST_TYPE_M3U:
#line 221 "playlist-file.c"
			{
				gchar* _tmp4_ = NULL;
				gchar* _tmp5_;
				gchar* _tmp6_;
#line 38 "../src/utils/playlist-file.vala"
				_tmp5_ = g4_load_m3u_file (file, uris, &_inner_error0_);
#line 38 "../src/utils/playlist-file.vala"
				_tmp4_ = _tmp5_;
#line 38 "../src/utils/playlist-file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../src/utils/playlist-file.vala"
					_g_object_unref0 (info);
#line 234 "playlist-file.c"
					goto __catch0_g_error;
				}
#line 38 "../src/utils/playlist-file.vala"
				_tmp6_ = _tmp4_;
#line 38 "../src/utils/playlist-file.vala"
				_tmp4_ = NULL;
#line 38 "../src/utils/playlist-file.vala"
				result = _tmp6_;
#line 38 "../src/utils/playlist-file.vala"
				_g_free0 (_tmp4_);
#line 38 "../src/utils/playlist-file.vala"
				_g_object_unref0 (info);
#line 38 "../src/utils/playlist-file.vala"
				return result;
#line 249 "playlist-file.c"
			}
#line 36 "../src/utils/playlist-file.vala"
			case G4_PLAY_LIST_TYPE_PLS:
#line 253 "playlist-file.c"
			{
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 40 "../src/utils/playlist-file.vala"
				_tmp8_ = g4_load_pls_file (file, uris, &_inner_error0_);
#line 40 "../src/utils/playlist-file.vala"
				_tmp7_ = _tmp8_;
#line 40 "../src/utils/playlist-file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../src/utils/playlist-file.vala"
					_g_object_unref0 (info);
#line 266 "playlist-file.c"
					goto __catch0_g_error;
				}
#line 40 "../src/utils/playlist-file.vala"
				_tmp9_ = _tmp7_;
#line 40 "../src/utils/playlist-file.vala"
				_tmp7_ = NULL;
#line 40 "../src/utils/playlist-file.vala"
				result = _tmp9_;
#line 40 "../src/utils/playlist-file.vala"
				_g_free0 (_tmp7_);
#line 40 "../src/utils/playlist-file.vala"
				_g_object_unref0 (info);
#line 40 "../src/utils/playlist-file.vala"
				return result;
#line 281 "playlist-file.c"
			}
			default:
#line 36 "../src/utils/playlist-file.vala"
			break;
#line 286 "playlist-file.c"
		}
#line 33 "../src/utils/playlist-file.vala"
		_g_object_unref0 (info);
#line 290 "playlist-file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 33 "../src/utils/playlist-file.vala"
		g_clear_error (&_inner_error0_);
#line 297 "playlist-file.c"
	}
	__finally0:
#line 33 "../src/utils/playlist-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/utils/playlist-file.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 33 "../src/utils/playlist-file.vala"
		g_clear_error (&_inner_error0_);
#line 33 "../src/utils/playlist-file.vala"
		return NULL;
#line 308 "playlist-file.c"
	}
#line 44 "../src/utils/playlist-file.vala"
	result = NULL;
#line 44 "../src/utils/playlist-file.vala"
	return result;
#line 314 "playlist-file.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 331 "playlist-file.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 353 "playlist-file.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 357 "playlist-file.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 363 "playlist-file.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 367 "playlist-file.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 371 "playlist-file.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 379 "playlist-file.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 407 "playlist-file.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 416 "playlist-file.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 430 "playlist-file.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 439 "playlist-file.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 453 "playlist-file.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 462 "playlist-file.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 471 "playlist-file.c"
}

gchar*
g4_load_m3u_file (GFile* file,
                  GPtrArray* uris,
                  GError** error)
{
	GFileInputStream* fis = NULL;
	GFileInputStream* _tmp0_;
	GBufferedInputStream* bis = NULL;
	GFileInputStream* _tmp1_;
	GBufferedInputStream* _tmp2_;
	GDataInputStream* dis = NULL;
	GBufferedInputStream* _tmp3_;
	GDataInputStream* _tmp4_;
	GFile* parent = NULL;
	GFile* _tmp5_;
	gsize length = 0UL;
	gchar* str = NULL;
	gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 47 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 47 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 48 "../src/utils/playlist-file.vala"
	_tmp0_ = g_file_read (file, NULL, &_inner_error0_);
#line 48 "../src/utils/playlist-file.vala"
	fis = _tmp0_;
#line 48 "../src/utils/playlist-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/utils/playlist-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 48 "../src/utils/playlist-file.vala"
		return NULL;
#line 508 "playlist-file.c"
	}
#line 49 "../src/utils/playlist-file.vala"
	_tmp1_ = fis;
#line 49 "../src/utils/playlist-file.vala"
	_tmp2_ = (GBufferedInputStream*) g_buffered_input_stream_new ((GInputStream*) _tmp1_);
#line 49 "../src/utils/playlist-file.vala"
	bis = _tmp2_;
#line 50 "../src/utils/playlist-file.vala"
	_tmp3_ = bis;
#line 50 "../src/utils/playlist-file.vala"
	_tmp4_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
#line 50 "../src/utils/playlist-file.vala"
	dis = _tmp4_;
#line 51 "../src/utils/playlist-file.vala"
	_tmp5_ = g_file_get_parent (file);
#line 51 "../src/utils/playlist-file.vala"
	parent = _tmp5_;
#line 52 "../src/utils/playlist-file.vala"
	length = (gsize) 0;
#line 53 "../src/utils/playlist-file.vala"
	str = NULL;
#line 54 "../src/utils/playlist-file.vala"
	while (TRUE) {
#line 532 "playlist-file.c"
		gchar* _tmp6_ = NULL;
		GDataInputStream* _tmp7_;
		gsize _tmp8_ = 0UL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* uri = NULL;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 54 "../src/utils/playlist-file.vala"
		_tmp7_ = dis;
#line 54 "../src/utils/playlist-file.vala"
		_tmp9_ = g_data_input_stream_read_line_utf8 (_tmp7_, &_tmp8_, NULL, &_inner_error0_);
#line 54 "../src/utils/playlist-file.vala"
		length = _tmp8_;
#line 54 "../src/utils/playlist-file.vala"
		_tmp6_ = _tmp9_;
#line 54 "../src/utils/playlist-file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/utils/playlist-file.vala"
			g_propagate_error (error, _inner_error0_);
#line 54 "../src/utils/playlist-file.vala"
			_g_free0 (str);
#line 54 "../src/utils/playlist-file.vala"
			_g_object_unref0 (parent);
#line 54 "../src/utils/playlist-file.vala"
			_g_object_unref0 (dis);
#line 54 "../src/utils/playlist-file.vala"
			_g_object_unref0 (bis);
#line 54 "../src/utils/playlist-file.vala"
			_g_object_unref0 (fis);
#line 54 "../src/utils/playlist-file.vala"
			return NULL;
#line 567 "playlist-file.c"
		}
#line 54 "../src/utils/playlist-file.vala"
		_tmp10_ = _tmp6_;
#line 54 "../src/utils/playlist-file.vala"
		_tmp6_ = NULL;
#line 54 "../src/utils/playlist-file.vala"
		_g_free0 (str);
#line 54 "../src/utils/playlist-file.vala"
		str = _tmp10_;
#line 54 "../src/utils/playlist-file.vala"
		_tmp11_ = str;
#line 54 "../src/utils/playlist-file.vala"
		if (!(_tmp11_ != NULL)) {
#line 54 "../src/utils/playlist-file.vala"
			_g_free0 (_tmp6_);
#line 54 "../src/utils/playlist-file.vala"
			break;
#line 585 "playlist-file.c"
		}
#line 55 "../src/utils/playlist-file.vala"
		_tmp12_ = str;
#line 55 "../src/utils/playlist-file.vala"
		_tmp13_ = g_strdup ((const gchar*) _tmp12_);
#line 55 "../src/utils/playlist-file.vala"
		uri = _tmp13_;
#line 56 "../src/utils/playlist-file.vala"
		if (length > ((gsize) 0)) {
#line 595 "playlist-file.c"
			const gchar* _tmp15_;
#line 56 "../src/utils/playlist-file.vala"
			_tmp15_ = uri;
#line 56 "../src/utils/playlist-file.vala"
			_tmp14_ = string_get (_tmp15_, (glong) 0) != '#';
#line 601 "playlist-file.c"
		} else {
#line 56 "../src/utils/playlist-file.vala"
			_tmp14_ = FALSE;
#line 605 "playlist-file.c"
		}
#line 56 "../src/utils/playlist-file.vala"
		if (_tmp14_) {
#line 609 "playlist-file.c"
			gchar* abs_uri = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GFile* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
#line 57 "../src/utils/playlist-file.vala"
			_tmp16_ = uri;
#line 57 "../src/utils/playlist-file.vala"
			_tmp17_ = string_replace (_tmp16_, "\r", "");
#line 57 "../src/utils/playlist-file.vala"
			_tmp18_ = _tmp17_;
#line 57 "../src/utils/playlist-file.vala"
			_tmp19_ = parent;
#line 57 "../src/utils/playlist-file.vala"
			_tmp20_ = g4_parse_relative_uri (_tmp18_, _tmp19_);
#line 57 "../src/utils/playlist-file.vala"
			_tmp21_ = _tmp20_;
#line 57 "../src/utils/playlist-file.vala"
			_g_free0 (_tmp18_);
#line 57 "../src/utils/playlist-file.vala"
			abs_uri = _tmp21_;
#line 58 "../src/utils/playlist-file.vala"
			_tmp22_ = abs_uri;
#line 58 "../src/utils/playlist-file.vala"
			if (_tmp22_ != NULL) {
#line 638 "playlist-file.c"
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 59 "../src/utils/playlist-file.vala"
				_tmp23_ = abs_uri;
#line 59 "../src/utils/playlist-file.vala"
				_tmp24_ = g_strdup ((const gchar*) _tmp23_);
#line 59 "../src/utils/playlist-file.vala"
				g_ptr_array_add (uris, _tmp24_);
#line 647 "playlist-file.c"
			}
#line 56 "../src/utils/playlist-file.vala"
			_g_free0 (abs_uri);
#line 651 "playlist-file.c"
		}
#line 54 "../src/utils/playlist-file.vala"
		_g_free0 (uri);
#line 54 "../src/utils/playlist-file.vala"
		_g_free0 (_tmp6_);
#line 657 "playlist-file.c"
	}
#line 62 "../src/utils/playlist-file.vala"
	_tmp25_ = g4_get_file_display_name (file);
#line 62 "../src/utils/playlist-file.vala"
	result = _tmp25_;
#line 62 "../src/utils/playlist-file.vala"
	_g_free0 (str);
#line 62 "../src/utils/playlist-file.vala"
	_g_object_unref0 (parent);
#line 62 "../src/utils/playlist-file.vala"
	_g_object_unref0 (dis);
#line 62 "../src/utils/playlist-file.vala"
	_g_object_unref0 (bis);
#line 62 "../src/utils/playlist-file.vala"
	_g_object_unref0 (fis);
#line 62 "../src/utils/playlist-file.vala"
	return result;
#line 675 "playlist-file.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 696 "playlist-file.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 718 "playlist-file.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 726 "playlist-file.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 732 "playlist-file.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 756 "playlist-file.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 765 "playlist-file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 784 "playlist-file.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 788 "playlist-file.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 794 "playlist-file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 804 "playlist-file.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 812 "playlist-file.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 816 "playlist-file.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 822 "playlist-file.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 832 "playlist-file.c"
}

gchar*
g4_load_pls_file (GFile* file,
                  GPtrArray* uris,
                  GError** error)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	GFileInputStream* fis = NULL;
	GFileInputStream* _tmp1_;
	GBufferedInputStream* bis = NULL;
	GFileInputStream* _tmp2_;
	GBufferedInputStream* _tmp3_;
	GDataInputStream* dis = NULL;
	GBufferedInputStream* _tmp4_;
	GDataInputStream* _tmp5_;
	GFile* parent = NULL;
	GFile* _tmp6_;
	gboolean list_found = FALSE;
	gsize length = 0UL;
	gint pos = 0;
	gchar* str = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 65 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (uris != NULL, NULL);
#line 66 "../src/utils/playlist-file.vala"
	_tmp0_ = g4_get_file_display_name (file);
#line 66 "../src/utils/playlist-file.vala"
	name = _tmp0_;
#line 67 "../src/utils/playlist-file.vala"
	_tmp1_ = g_file_read (file, NULL, &_inner_error0_);
#line 67 "../src/utils/playlist-file.vala"
	fis = _tmp1_;
#line 67 "../src/utils/playlist-file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/utils/playlist-file.vala"
		g_propagate_error (error, _inner_error0_);
#line 67 "../src/utils/playlist-file.vala"
		_g_free0 (name);
#line 67 "../src/utils/playlist-file.vala"
		return NULL;
#line 878 "playlist-file.c"
	}
#line 68 "../src/utils/playlist-file.vala"
	_tmp2_ = fis;
#line 68 "../src/utils/playlist-file.vala"
	_tmp3_ = (GBufferedInputStream*) g_buffered_input_stream_new ((GInputStream*) _tmp2_);
#line 68 "../src/utils/playlist-file.vala"
	bis = _tmp3_;
#line 69 "../src/utils/playlist-file.vala"
	_tmp4_ = bis;
#line 69 "../src/utils/playlist-file.vala"
	_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp4_);
#line 69 "../src/utils/playlist-file.vala"
	dis = _tmp5_;
#line 70 "../src/utils/playlist-file.vala"
	_tmp6_ = g_file_get_parent (file);
#line 70 "../src/utils/playlist-file.vala"
	parent = _tmp6_;
#line 71 "../src/utils/playlist-file.vala"
	list_found = FALSE;
#line 72 "../src/utils/playlist-file.vala"
	length = (gsize) 0;
#line 73 "../src/utils/playlist-file.vala"
	pos = -1;
#line 74 "../src/utils/playlist-file.vala"
	str = NULL;
#line 75 "../src/utils/playlist-file.vala"
	while (TRUE) {
#line 906 "playlist-file.c"
		gchar* _tmp7_ = NULL;
		GDataInputStream* _tmp8_;
		gsize _tmp9_ = 0UL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* line = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 75 "../src/utils/playlist-file.vala"
		_tmp8_ = dis;
#line 75 "../src/utils/playlist-file.vala"
		_tmp10_ = g_data_input_stream_read_line_utf8 (_tmp8_, &_tmp9_, NULL, &_inner_error0_);
#line 75 "../src/utils/playlist-file.vala"
		length = _tmp9_;
#line 75 "../src/utils/playlist-file.vala"
		_tmp7_ = _tmp10_;
#line 75 "../src/utils/playlist-file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/utils/playlist-file.vala"
			g_propagate_error (error, _inner_error0_);
#line 75 "../src/utils/playlist-file.vala"
			_g_free0 (str);
#line 75 "../src/utils/playlist-file.vala"
			_g_object_unref0 (parent);
#line 75 "../src/utils/playlist-file.vala"
			_g_object_unref0 (dis);
#line 75 "../src/utils/playlist-file.vala"
			_g_object_unref0 (bis);
#line 75 "../src/utils/playlist-file.vala"
			_g_object_unref0 (fis);
#line 75 "../src/utils/playlist-file.vala"
			_g_free0 (name);
#line 75 "../src/utils/playlist-file.vala"
			return NULL;
#line 946 "playlist-file.c"
		}
#line 75 "../src/utils/playlist-file.vala"
		_tmp11_ = _tmp7_;
#line 75 "../src/utils/playlist-file.vala"
		_tmp7_ = NULL;
#line 75 "../src/utils/playlist-file.vala"
		_g_free0 (str);
#line 75 "../src/utils/playlist-file.vala"
		str = _tmp11_;
#line 75 "../src/utils/playlist-file.vala"
		_tmp12_ = str;
#line 75 "../src/utils/playlist-file.vala"
		if (!(_tmp12_ != NULL)) {
#line 75 "../src/utils/playlist-file.vala"
			_g_free0 (_tmp7_);
#line 75 "../src/utils/playlist-file.vala"
			break;
#line 964 "playlist-file.c"
		}
#line 76 "../src/utils/playlist-file.vala"
		_tmp13_ = str;
#line 76 "../src/utils/playlist-file.vala"
		_tmp14_ = string_strip ((const gchar*) _tmp13_);
#line 76 "../src/utils/playlist-file.vala"
		line = _tmp14_;
#line 77 "../src/utils/playlist-file.vala"
		_tmp16_ = line;
#line 77 "../src/utils/playlist-file.vala"
		_tmp17_ = strlen (_tmp16_);
#line 77 "../src/utils/playlist-file.vala"
		_tmp18_ = _tmp17_;
#line 77 "../src/utils/playlist-file.vala"
		if (_tmp18_ > 1) {
#line 980 "playlist-file.c"
			const gchar* _tmp19_;
#line 77 "../src/utils/playlist-file.vala"
			_tmp19_ = line;
#line 77 "../src/utils/playlist-file.vala"
			_tmp15_ = string_get (_tmp19_, (glong) 0) == '[';
#line 986 "playlist-file.c"
		} else {
#line 77 "../src/utils/playlist-file.vala"
			_tmp15_ = FALSE;
#line 990 "playlist-file.c"
		}
#line 77 "../src/utils/playlist-file.vala"
		if (_tmp15_) {
#line 994 "playlist-file.c"
			GCompareFunc _tmp20_;
			const gchar* _tmp21_;
#line 78 "../src/utils/playlist-file.vala"
			_tmp20_ = ((GCompareFunc) g_strcmp0);
#line 78 "../src/utils/playlist-file.vala"
			_tmp21_ = line;
#line 78 "../src/utils/playlist-file.vala"
			list_found = _tmp20_ (_tmp21_, "[playlist]") == 0;
#line 1003 "playlist-file.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 79 "../src/utils/playlist-file.vala"
			if (list_found) {
#line 1008 "playlist-file.c"
				const gchar* _tmp23_;
#line 79 "../src/utils/playlist-file.vala"
				_tmp23_ = line;
#line 79 "../src/utils/playlist-file.vala"
				pos = string_index_of_char (_tmp23_, (gunichar) '=', 0);
#line 79 "../src/utils/playlist-file.vala"
				_tmp22_ = pos > 0;
#line 1016 "playlist-file.c"
			} else {
#line 79 "../src/utils/playlist-file.vala"
				_tmp22_ = FALSE;
#line 1020 "playlist-file.c"
			}
#line 79 "../src/utils/playlist-file.vala"
			if (_tmp22_) {
#line 1024 "playlist-file.c"
				const gchar* _tmp24_;
#line 80 "../src/utils/playlist-file.vala"
				_tmp24_ = line;
#line 80 "../src/utils/playlist-file.vala"
				if (g_str_has_prefix (_tmp24_, "File")) {
#line 1030 "playlist-file.c"
					gchar* uri = NULL;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					gchar* abs_uri = NULL;
					const gchar* _tmp30_;
					GFile* _tmp31_;
					gchar* _tmp32_;
					const gchar* _tmp33_;
#line 81 "../src/utils/playlist-file.vala"
					_tmp25_ = line;
#line 81 "../src/utils/playlist-file.vala"
					_tmp26_ = string_substring (_tmp25_, (glong) (pos + 1), (glong) -1);
#line 81 "../src/utils/playlist-file.vala"
					_tmp27_ = _tmp26_;
#line 81 "../src/utils/playlist-file.vala"
					_tmp28_ = string_strip (_tmp27_);
#line 81 "../src/utils/playlist-file.vala"
					_tmp29_ = _tmp28_;
#line 81 "../src/utils/playlist-file.vala"
					_g_free0 (_tmp27_);
#line 81 "../src/utils/playlist-file.vala"
					uri = _tmp29_;
#line 82 "../src/utils/playlist-file.vala"
					_tmp30_ = uri;
#line 82 "../src/utils/playlist-file.vala"
					_tmp31_ = parent;
#line 82 "../src/utils/playlist-file.vala"
					_tmp32_ = g4_parse_relative_uri (_tmp30_, _tmp31_);
#line 82 "../src/utils/playlist-file.vala"
					abs_uri = _tmp32_;
#line 83 "../src/utils/playlist-file.vala"
					_tmp33_ = abs_uri;
#line 83 "../src/utils/playlist-file.vala"
					if (_tmp33_ != NULL) {
#line 1068 "playlist-file.c"
						const gchar* _tmp34_;
						gchar* _tmp35_;
#line 84 "../src/utils/playlist-file.vala"
						_tmp34_ = abs_uri;
#line 84 "../src/utils/playlist-file.vala"
						_tmp35_ = g_strdup ((const gchar*) _tmp34_);
#line 84 "../src/utils/playlist-file.vala"
						g_ptr_array_add (uris, _tmp35_);
#line 1077 "playlist-file.c"
					}
#line 80 "../src/utils/playlist-file.vala"
					_g_free0 (abs_uri);
#line 80 "../src/utils/playlist-file.vala"
					_g_free0 (uri);
#line 1083 "playlist-file.c"
				} else {
					const gchar* _tmp36_;
#line 85 "../src/utils/playlist-file.vala"
					_tmp36_ = line;
#line 85 "../src/utils/playlist-file.vala"
					if (g_ascii_strncasecmp (_tmp36_, "X-GNOME-Title", (gsize) pos) == 0) {
#line 1090 "playlist-file.c"
						gchar* title = NULL;
						const gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						const gchar* _tmp42_;
						gint _tmp43_;
						gint _tmp44_;
#line 86 "../src/utils/playlist-file.vala"
						_tmp37_ = line;
#line 86 "../src/utils/playlist-file.vala"
						_tmp38_ = string_substring (_tmp37_, (glong) (pos + 1), (glong) -1);
#line 86 "../src/utils/playlist-file.vala"
						_tmp39_ = _tmp38_;
#line 86 "../src/utils/playlist-file.vala"
						_tmp40_ = string_strip (_tmp39_);
#line 86 "../src/utils/playlist-file.vala"
						_tmp41_ = _tmp40_;
#line 86 "../src/utils/playlist-file.vala"
						_g_free0 (_tmp39_);
#line 86 "../src/utils/playlist-file.vala"
						title = _tmp41_;
#line 87 "../src/utils/playlist-file.vala"
						_tmp42_ = title;
#line 87 "../src/utils/playlist-file.vala"
						_tmp43_ = strlen (_tmp42_);
#line 87 "../src/utils/playlist-file.vala"
						_tmp44_ = _tmp43_;
#line 87 "../src/utils/playlist-file.vala"
						if (_tmp44_ > 0) {
#line 1122 "playlist-file.c"
							const gchar* _tmp45_;
							gchar* _tmp46_;
#line 88 "../src/utils/playlist-file.vala"
							_tmp45_ = title;
#line 88 "../src/utils/playlist-file.vala"
							_tmp46_ = g_strdup (_tmp45_);
#line 88 "../src/utils/playlist-file.vala"
							_g_free0 (name);
#line 88 "../src/utils/playlist-file.vala"
							name = _tmp46_;
#line 1133 "playlist-file.c"
						}
#line 85 "../src/utils/playlist-file.vala"
						_g_free0 (title);
#line 1137 "playlist-file.c"
					}
				}
			}
		}
#line 75 "../src/utils/playlist-file.vala"
		_g_free0 (line);
#line 75 "../src/utils/playlist-file.vala"
		_g_free0 (_tmp7_);
#line 1146 "playlist-file.c"
	}
#line 92 "../src/utils/playlist-file.vala"
	result = name;
#line 92 "../src/utils/playlist-file.vala"
	_g_free0 (str);
#line 92 "../src/utils/playlist-file.vala"
	_g_object_unref0 (parent);
#line 92 "../src/utils/playlist-file.vala"
	_g_object_unref0 (dis);
#line 92 "../src/utils/playlist-file.vala"
	_g_object_unref0 (bis);
#line 92 "../src/utils/playlist-file.vala"
	_g_object_unref0 (fis);
#line 92 "../src/utils/playlist-file.vala"
	return result;
#line 1162 "playlist-file.c"
}

gchar*
g4_parse_relative_uri (const gchar* uri,
                       GFile* parent)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	GFile* _tmp9_ = NULL;
	GFile* _tmp10_ = NULL;
	GFile* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp15_;
	gchar* result;
#line 95 "../src/utils/playlist-file.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 96 "../src/utils/playlist-file.vala"
	_tmp1_ = strlen (uri);
#line 96 "../src/utils/playlist-file.vala"
	_tmp2_ = _tmp1_;
#line 96 "../src/utils/playlist-file.vala"
	if (_tmp2_ > 0) {
#line 96 "../src/utils/playlist-file.vala"
		_tmp0_ = string_get (uri, (glong) 0) == '/';
#line 1188 "playlist-file.c"
	} else {
#line 96 "../src/utils/playlist-file.vala"
		_tmp0_ = FALSE;
#line 1192 "playlist-file.c"
	}
#line 96 "../src/utils/playlist-file.vala"
	if (_tmp0_) {
#line 1196 "playlist-file.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 97 "../src/utils/playlist-file.vala"
		_tmp3_ = g_file_new_for_path (uri);
#line 97 "../src/utils/playlist-file.vala"
		_tmp4_ = _tmp3_;
#line 97 "../src/utils/playlist-file.vala"
		_tmp5_ = g_file_get_uri (_tmp4_);
#line 97 "../src/utils/playlist-file.vala"
		_tmp6_ = _tmp5_;
#line 97 "../src/utils/playlist-file.vala"
		_g_object_unref0 (_tmp4_);
#line 97 "../src/utils/playlist-file.vala"
		result = _tmp6_;
#line 97 "../src/utils/playlist-file.vala"
		return result;
#line 1215 "playlist-file.c"
	} else {
#line 98 "../src/utils/playlist-file.vala"
		if (g4_is_valid_uri (uri, G_URI_FLAGS_NONE)) {
#line 1219 "playlist-file.c"
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_;
#line 100 "../src/utils/playlist-file.vala"
			if (g_str_has_prefix (uri, "file://")) {
#line 100 "../src/utils/playlist-file.vala"
				_tmp7_ = (const gchar*) uri;
#line 1226 "playlist-file.c"
			} else {
#line 100 "../src/utils/playlist-file.vala"
				_tmp7_ = NULL;
#line 1230 "playlist-file.c"
			}
#line 100 "../src/utils/playlist-file.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 100 "../src/utils/playlist-file.vala"
			result = _tmp8_;
#line 100 "../src/utils/playlist-file.vala"
			return result;
#line 1238 "playlist-file.c"
		}
	}
#line 102 "../src/utils/playlist-file.vala"
	_tmp9_ = parent;
#line 102 "../src/utils/playlist-file.vala"
	_tmp10_ = NULL;
#line 102 "../src/utils/playlist-file.vala"
	if (_tmp9_ != NULL) {
#line 1247 "playlist-file.c"
		GFile* _tmp11_;
#line 102 "../src/utils/playlist-file.vala"
		_tmp11_ = g_file_resolve_relative_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_file_get_type (), GFile), uri);
#line 102 "../src/utils/playlist-file.vala"
		_g_object_unref0 (_tmp10_);
#line 102 "../src/utils/playlist-file.vala"
		_tmp10_ = _tmp11_;
#line 1255 "playlist-file.c"
	}
#line 102 "../src/utils/playlist-file.vala"
	_tmp12_ = _tmp10_;
#line 102 "../src/utils/playlist-file.vala"
	_tmp13_ = NULL;
#line 102 "../src/utils/playlist-file.vala"
	if (_tmp12_ != NULL) {
#line 1263 "playlist-file.c"
		gchar* _tmp14_;
#line 102 "../src/utils/playlist-file.vala"
		_tmp14_ = g_file_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, g_file_get_type (), GFile));
#line 102 "../src/utils/playlist-file.vala"
		_g_free0 (_tmp13_);
#line 102 "../src/utils/playlist-file.vala"
		_tmp13_ = _tmp14_;
#line 1271 "playlist-file.c"
	}
#line 102 "../src/utils/playlist-file.vala"
	_tmp15_ = _tmp13_;
#line 102 "../src/utils/playlist-file.vala"
	_tmp13_ = NULL;
#line 102 "../src/utils/playlist-file.vala"
	result = _tmp15_;
#line 102 "../src/utils/playlist-file.vala"
	_g_free0 (_tmp13_);
#line 102 "../src/utils/playlist-file.vala"
	_g_object_unref0 (_tmp10_);
#line 102 "../src/utils/playlist-file.vala"
	return result;
#line 1285 "playlist-file.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

